from PyQt5.QtCore import pyqtProperty, QCoreApplication, QObject, QUrl
from PyQt5.QtQml import qmlRegisterType, QQmlComponent, QQmlEngine


class ListField(QObject):

    def __init__(self,name,id=0,signalise=False,selected=False,parent=None):
        super().__init__(parent)
        self._name = name
        self._id = id
        self._signalise = signalise
        self._selected=selected
    
    
    ############################# NAME ######################################
    # DISPLAYED NAME
    @pyqtProperty('QString')
    def name(self):
        return self._name
    
    @name.setter
    def name(self, name):
        self._name = name
    

    ############################# ID #######################################
    # INTERNAL ID
    @pyqtProperty(int)
    def id(self):
        return self._id
    
    @id.setter
    def id(self, id):
        self._id = id

    ############################# signalise ################################
    # SHOULD BE SHOWN IN SPECIAL WAY
    @pyqtProperty('bool')
    def signalise(self):
        return self._signalise

    @signalise.setter
    def signalise(self,signalise):
        self._signalise=signalise

    ############################# SELECTED ##################################
    # IS SELECTED
    @pyqtProperty('bool')
    def selected(self):
        return self._selected

    @selected.setter
    def selected(self, selected):
        self._selected=selected
