

from PyQt5.QtCore import Qt, QCoreApplication, pyqtSlot, pyqtProperty
from UM.Application import Application

from UM.Qt.ListModel import ListModel


class PrintersModel(ListModel):

    PrinterNameRole = Qt.UserRole + 1

    def __init__(self, parent=None):
        super().__init__(parent)
        self._printerTree = Application.getInstance()._printerTree
        self.addRoleName(self.PrinterNameRole, "name")
        self._update()

    def _update(self):
        items = []

        node = self._printerTree.getPrintersNode()
        printers = node.getCurrentNode()[2]

        for i in printers:
            item = {"name": i}
            items.append(item)
        self.setItems(items)
