from PyQt5.QtCore import pyqtProperty, QCoreApplication, QObject, QUrl
from PyQt5.QtQml import qmlRegisterType, QQmlComponent, QQmlEngine


# This is the type that will be registered with QML.  It must be a
# sub-class of QObject.
class Printer(QObject):
    def __init__(self):
        super().__init__(None)
        
        # Initialise the value of the properties.
        self._name = ''
        self._id = 0
    
    def __init__(self,name,id=0,parent=None):
        super().__init__(parent)
        self._name = name
        self._id = id
    
    # Define the getter of the 'name' property.  The C++ type of the
    # property is QString which Python will convert to and from a string.
    @pyqtProperty('QString')
    def name(self):
        return self._name
    
    # Define the setter of the 'name' property.
    @name.setter
    def name(self, name):
        self._name = name
    
    # Define the getter of the 'id' property.  The C++ type and
    # Python type of the property is int.
    @pyqtProperty(int)
    def id(self):
        return self._id
    
    # Define the setter of the 'id' property.
    @id.setter
    def id(self, id):
        self._id = id
