
from PyQt5.QtCore import QObject, pyqtSlot, pyqtSignal,QVariant,pyqtProperty

class ViewProxy(QObject):
    """
    Allows to change state of model drawing functions
    """
    def __init__(self,parent=None):
        super().__init__(parent)
        self._showIdle=False


    idleMovesBehaviourChanged = pyqtSignal(bool)
    instance=None

    @pyqtProperty('bool')
    def idleMoves(self):
        return self._showIdle

    @idleMoves.setter
    def idleMoves(self,show):
        self._showIdle=show
        self.idleMovesBehaviourChanged.emit(show)

def createViewProxy(engine, script_engine):
    if(ViewProxy.instance==None):
        ViewProxy.instance=ViewProxy()
    return ViewProxy.instance






