#########################################################
# Calculating relations - move to separate class
#########################################################

    def _calculateShapeRelations(self, shapes):
        if len(shapes) < 2:
            return None

        for section in shapes[0]['segments']:
            print("RRRRRRRRRRRR")
            wn = self.wn_PointInPolygon(section[0], shapes[1]['segments'])
            if wn != 0:
                print("====================================>")
            # else:
            #     print("-")

    # wn = the winding number (=0 only when P is outside)
    def wn_PointInPolygon(self, p, shape):#n = size of shape
        wn = 0

        for section in shape:
            if section[0][1] <= p[1]:
                if section[1][1] > p[1]:
                    if self._isLeft(section[0], section[1], p) > 0:
                        ++wn
            else:
                if section[1][1] <= p[1]:
                    if self._isLeft(section[0], section[1], p) < 0:
                        --wn

        return wn

    # Return: >0 for P2 left of the line through P0 and P1
    #         =0 for P2  on the line
    #         <0 for P2  right of the line
    def _isLeft(self, p0, p1, p2):
        return (p1[0] - p0[0]) * (p2[1] - p0[1]) - (p2[0] - p0[0]) * (p1[1] - p0[1])

#########################################################
# Unused leftovers - temp
#########################################################
    def __debug_removeUnsedVertices(self, indexed_vertices, indexed_shape):
        usedVerticesCount = [0] * len(indexed_vertices)
        usedVerticies = list(indexed_vertices)

        for section in indexed_shape:
            usedVerticesCount[section[0]] += 1
            usedVerticesCount[section[1]] += 1


        for i, count in enumerate(usedVerticesCount):
            if count == 0:
                usedVerticies[i] = np.asarray([100., 100.], dtype=np.float32)

        return usedVerticies

    def _closeShape(self, indexed_vertices, shapes):
        close_polygons = []
        for shape in shapes:
            face = self._prepareDataForTriangle(indexed_vertices, shape)
            t = triangle.triangulate(face, 'p')

            new_polygons = t['triangles']
            reindexed_vertices = t['vertices']

            for polygon in new_polygons:
                close_polygons.append(reindexed_vertices[polygon[0]])
                close_polygons.append(reindexed_vertices[polygon[1]])
                close_polygons.append(reindexed_vertices[polygon[2]])

        return close_polygons

    def _prepareDataForTriangle(self, indexed_vertices, shape):
        new_shape = []
        new_vertices = []

        used_vertices = []

        for i, section in enumerate(shape):
            value_0 = indexed_vertices[section[0]]
            value_1 = indexed_vertices[section[1]]

            if section[0] not in used_vertices:
                used_vertices.append(section[0])
                new_vertices.append(value_0)
                vert_0_index = len(new_vertices) - 1
            else:
                vert_0_index = self._findIndex(new_vertices, value_0)

            if section[1] not in used_vertices:
                used_vertices.append(section[1])
                new_vertices.append(value_1)
                vert_1_index = len(new_vertices) - 1
            else:
                vert_1_index = self._findIndex(new_vertices, value_1)

            new_shape.append([vert_0_index, vert_1_index])

        t_data = {}
        t_data['vertices'] = np.array(new_vertices)
        t_data['segments'] = np.array(new_shape)

        return t_data

    def _prepareIndexedSections(self, sections, indexed_vertices):
        segments = []

        for segment in sections:
            segment_1 = None
            segment_2 = None

            for i, vertex in enumerate(indexed_vertices):
                if self._v_eq(vertex, segment[0]):
                    segment_1 = i
                if self._v_eq(vertex, segment[1]):
                    segment_2 = i
                if segment_1 is not None and segment_2 is not None:
                    segments.append([segment_1, segment_2])
                    break

        return segments

    def _calculateVertexUse(self, indexed_sections, vertex_count):
        vertex_use = [0] * vertex_count

        for section in indexed_sections:
            vertex_use[section[0]] += 1
            vertex_use[section[1]] += 1

        return vertex_use

    def _prepareIndexedVertices(self, sections):
        indexed_vertices = []

        for section in sections:
            indexed_vertices.append(section[0])
            indexed_vertices.append(section[1])

        self._removeDuplicates(indexed_vertices)

        return indexed_vertices

    def _removeDuplicates(self, vertex_list):
        uniq = []

        for vertex in vertex_list:
            for element in uniq:
                if (element == vertex).all():
                    break
            else:
                uniq.append(vertex)

        vertex_list.clear()
        vertex_list.extend(uniq)

  def floodfill_recursion(self, matrix, x=0, y=0):
        # "hidden" stop clause - not reinvoking for "c" or "b", only for "a".
        if matrix[x][y] == 0:
            matrix[x][y] = 2
            # recursively invoke flood fill on all surrounding cells:
            if x > 0:
                self.__floodfill(matrix, x - 1, y)
            if x < len(matrix) - 1:
                self.__floodfill(matrix, x + 1, y)
            if y > 0:
                self.__floodfill(matrix, x, y - 1)
            if y < len(matrix[x]) - 1:
                self.__floodfill(matrix, x, y + 1)

    def fill_contours_numpp(self, arr):
        accu_up = np.maximum.accumulate(arr, 1)
        accu_down = np.maximum.accumulate(arr[:, ::-1], 1)[:, ::-1]
        accu_right = np.maximum.accumulate(arr, 0)
        accu_left = np.maximum.accumulate(arr[::-1, :], 0)[::-1, :]

        self.__debug_showMatrix(accu_up)
        self.__debug_showMatrix(accu_down)
        self.__debug_showMatrix(accu_right)
        self.__debug_showMatrix(accu_left)

        return accu_up & accu_down & accu_right & accu_left

    ###########################################################################
    #
    ###########################################################################
    # self.fillpolyPIL(shape['segments'])
    def fillpolyPIL(self, shape):
        from PIL import Image, ImageDraw

        # polygon = [(x1,y1),(x2,y2),...] or [x1,y1,x2,y2,...]
        # width = ?
        # height = ?

        polygon = []
        for segment in shape:
            x = round(segment[0][0] - math.floor(self.max_bottom))
            y = round(segment[0][1] - math.floor(self.max_left))

            polygon.append((y,x))
        #polygon.append((round(shape[0][0][1]), shape[0][0][0]))

        img = Image.new('L', (self.m_width + 2, self.m_height + 2), 0)
        ImageDraw.Draw(img).polygon(polygon, outline=1, fill=1)
        mask = np.array(img)

        # np.set_printoptions(threshold=np.nan)
        # print(mask)

        for y in reversed(range(self.m_height + 2)):
            for x in range(self.m_width + 2):
                print(mask[y][x], end=" ")
            print()

    # self.raster(shape['segments'])
    def raster(self, poly):
        coords = []
        i = 0
        try:
            print(len(poly))
            for segment in poly:
                print(i, ": ", segment[0], " - ", segment[1])
                i += 1

                t1 = segment[0]
                t2 = segment[1]
                xdef = t1[0] - t2[0]
                ydef = t1[1] - t2[1]
                if abs(xdef) > 1:
                    lo = min(t1[0], t2[0])
                    hi = max(t1[0], t2[0])
                    j = lo
                    while (j <= hi):
                        new = (j, t1[1])
                        coords.append(new)
                        j += 1
                if abs(ydef) > 1:
                    lo = min(t1[1], t2[1])
                    hi = max(t1[1], t2[1])
                    j = lo
                    while (j <= hi):
                        new = (t1[0], j)
                        coords.append(new)
                        j += 1
        except:
            print("ZUO:    ", i)

        for coord in coords:
            try:
                self.joint_matrix[int(round(coord[0])) + abs(math.floor(self.max_left))][int(round(coord[1])) + abs(math.floor(self.max_bottom))] = 1
            except:
                print("Except: ", int(round(coord[0])) + abs(math.floor(self.max_left)), "  ", int(round(coord[1])) + abs(math.floor(self.max_bottom)))





    # def bresenham_line(self, x, y, x2, y2):
    #     """Brensenham line algorithm"""
    #     steep = 0
    #     coords = []
    #
    #     dx = abs(x2 - x)
    #
    #     if (x2 - x) > 0:
    #         sx = 1
    #     else:
    #         sx = -1
    #
    #     dy = abs(y2 - y)
    #     if (y2 - y) > 0:
    #         sy = 1
    #     else:
    #         sy = -1
    #
    #     if dy > dx:
    #         steep = 1
    #         x, y = y, x
    #         dx, dy = dy,dx
    #         sx, sy = sy,sx
    #
    #     d = (2 * dy) - dx
    #     for i in range(0, int(dx)):
    #         if steep:
    #             coords.append((y, x))
    #         else:
    #             coords.append((x, y))
    #
    #         while d >= 0:
    #             y = y + sy
    #             d = d - (2 * dx)
    #
    #         x = x + sx
    #         d = d + (2 * dy)
    #
    #     coords.append((x2, y2))
    #
    #     print("====>", coords)
    #     for coord in coords:
    #         try:
    #             self.joint_matrix[int(round(coord[0])) + abs(math.floor(self.max_left))][int(round(coord[1])) + abs(math.floor(self.max_bottom))] = 1
    #         except:
    #             print("Except: ", int(round(coord[0])) + abs(math.floor(self.max_left)), "  ", int(round(coord[1])) + abs(math.floor(self.max_bottom)))
    #
    #
    #     return coords

# Bitmap.line = line
#
# bitmap = Bitmap(17, 17)
# for points in ((1, 8, 8, 16), (8, 16, 16, 8), (16, 8, 8, 1), (8, 1, 1, 8)):
#     bitmap.line(*points)
# bitmap.chardisplay()

    def __markBaseFill2(self, shapes):
        for y in reversed(range(self.m_height)):
            for x in range(self.m_width):
                point = [y + self.max_bottom, x + self.max_left ]
                print(point)
                for shape in shapes:
                    wn = self.wn_PointInPolygon(point, shape['segments'])

                    if wn != 0:
                        self.joint_matrix[x][y] += 1
            print()

    #########################################################
    # Calculating relations - move to separate class
    #########################################################

    # def _calculateShapeRelations(self, shapes):
    #     if len(shapes) < 2:
    #         return None
    #
    #     for section in shapes[0]['segments']:
    #         print("RRRRRRRRRRRR")
    #         wn = self.wn_PointInPolygon(section[0], shapes[1]['segments'])
    #         if wn != 0:
    #             print("====================================>")
    #         # else:
    #         #     print("-")

    # wn = the winding number (=0 only when P is outside)
    def wn_PointInPolygon(self, p, shape):  # n = size of shape
        wn = 0

        for section in shape:
            if section[0][1] <= p[1]:
                if section[1][1] > p[1]:
                    if self._isLeft(section[0], section[1], p) > 0:
                        wn += 1
            else:
                if section[1][1] <= p[1]:
                    if self._isLeft(section[0], section[1], p) < 0:
                        wn -= 1

        return wn

    # Return: >0 for P2 left of the line through P0 and P1
    #         =0 for P2  on the line
    #         <0 for P2  right of the line
    def _isLeft(self, p0, p1, p2):
        return (p1[0] - p0[0]) * (p2[1] - p0[1]) - (p2[0] - p0[0]) * (p1[1] - p0[1])

def CalculateClosingPolygons(shapes):
    indexed_vertices = []
    indexed_sections = []
    holes = []

    for shape in shapes:
        if shape['fill'] is not True:
            holes.append(shape['fill'])

        for segment in shape['segments']:
            indexed_sections.append(getIndexedSegement(indexed_vertices, np.array(segment[0], dtype=np.float32), np.array(segment[1], dtype=np.float32)))

    t_data = dict()
    t_data['vertices'] = np.array(indexed_vertices)
    t_data['segments'] = np.array(indexed_sections)

    if holes:
        t_data['holes'] = np.array(holes)

    t = triangle.triangulate(t_data, 'p')

    new_polygons = t['triangles']
    reindexed_vertices = t['vertices']

    close_polygons = []
    for polygon in new_polygons:
        close_polygons.append(reindexed_vertices[polygon[0]])
        close_polygons.append(reindexed_vertices[polygon[1]])
        close_polygons.append(reindexed_vertices[polygon[2]])

    return close_polygons


def flood_fill(matrix, x=0, y=0):
    stack = list()

    stack.append((x, y))

    while stack:
        curr = stack.pop()
        x, y = curr[0], curr[1]

        matrix[x][y] = 2

        if x + 1 < len(matrix) and matrix[x + 1][y] == 0:
            stack.append((x + 1, y))
        if 1 <= x and matrix[x - 1][y] == 0:
            stack.append((x - 1, y))
        if y + 1 < len(matrix[x]) and matrix[x][y + 1] == 0:
            stack.append((x, y + 1))
        if 1 <= y and matrix[x][y - 1] == 0:
            stack.append((x, y - 1))

    matrix[matrix == 0] = 1
    matrix[matrix == 2] = 0