import QtQuick 2.4
import QtQuick.Layouts 1.1


import UM 1.3 as UM
import "../singletons"
import "../tweaks"

Item {
    property alias buttonText: buttonText.text
    property alias buttonIcon: buttonIcon.source
    property alias buttonAction: mouseArea

    property alias helpText: buttonTweaks.helpText

    // Connections
    // {
    //     target:mouseArea
    //     onClicked:UM.Selection.isDeaf = false;
    // }

    property alias deactivateButton: deactivateIndicator.visible

    property double buttonIconSizeRatio: 0.24

    Layout.preferredHeight: Globals.buttonHeight
    Layout.fillWidth: true

    MouseArea {
        id: mouseArea
        anchors.fill: parent
    }

    ColumnLayout {
        anchors.fill: parent
        spacing: 0

        Rectangle {
            Layout.fillWidth: true
            Layout.fillHeight: true
            color: Colors.actionButtonBackground

            Image {
                id: buttonIcon
                anchors.left: parent.left
                anchors.verticalCenter: parent.verticalCenter
                anchors.margins: parent.width * 0.2
                height: parent.height * buttonIconSizeRatio
                fillMode: Image.PreserveAspectFit
                mipmap: true

                source: "../images/undo_white.svg"
            }

            Item {
                anchors.right: parent.right
                anchors.leftMargin: parent.width * 0.15
                width: parent.width * 0.85 - buttonIcon.width
                height: parent.height

                Text {
                    id: buttonText
                    anchors.centerIn: parent
                    font.pixelSize: Globals.actionButtonFontPixelSize
                    font.capitalization: Font.AllUppercase
                    font.weight: Font.Bold
                    font.family: Fonts.boxed

                    color: Colors.buttonText
                    text: "button"
                }
            }
        }

        Rectangle {
            Layout.preferredHeight: Globals.decoratorHeight
            Layout.fillWidth: true
            color: Colors.actionButtonDecorator
        }

        BottomShadow {}
    }

    //Non-active button layer
    Rectangle {
        id: deactivateIndicator
        anchors.fill: parent
        visible: false
        color: Colors.buttonDeactivator
    }

    ButtonTweaks{
        id: buttonTweaks
        hoverIndicatorEnabled: !deactivateIndicator.visible
        helpEnabled: !deactivateIndicator.visible
    }
}
