import QtQuick 2.4

import "../singletons"

ButtonWithMenuForm {
    property url contentLoaderSource
    property int menuHeight
    property int menuWidth
    property bool isOpen : false

    buttonAction.onClicked: openMenu()

    Connections {
        target: menu
        onClosed: onMenuClosed()
    }

    function openMenu(){
        isOpen = true;
        markButtonAsClicked()
        menu.open()
    }

    function onMenuClosed(){
        isOpen =false;
        markButtonAsActive()
    }

    function closeMenu(){
        isOpen=false;
        menu.close()
    }
}
