import QtQuick 2.4
import QtQuick.Layouts 1.1
import QtQuick.Controls 1.0

import "../../buttons"
import "../../list"
import "../../tweaks"
import "../../singletons"

import Gence 1.0 as Gence
import Settings 1.0 as Settings


Item {
    property alias printerListHeight: printersLV.contentHeight

    ColumnLayout {
        anchors.fill: parent
        spacing: parent.width * 0.05
        ListView {
            id:printersLV
            Layout.fillHeight: true
            Layout.fillWidth: true
            spacing: parent.width * 0.05
            interactive: false

            onCurrentItemChanged:
            {
                if(currentItem != null)
                    currentOption = currentItem.menuButtonText

                Settings.Notifications.printer = currentItem.menuButtonText
            }

            model: Gence.PrintersModel {}

            delegate: MenuOptionButton {
                menuButtonText: name
                buttonHelpText: Help.printerButton
            }
        }
    }
}
