import QtQuick 2.4
import QtQuick.Layouts 1.1

import "../../singletons"
import "../../spinBox"
import "../../tweaks"
import "../../buttons"

Item {


    property alias resetAction: placeButton.buttonClickedAction

    property alias xySpinBox: xySpinBox;
    property alias yzSpinBox: yzSpinBox;
    property alias xzSpinBox: xzSpinBox;



    ColumnLayout {
        id: layout
        spacing: height * 0.08
        anchors.fill: parent
        LabeledSpinBox {
            id: yzSpinBox
            spinBoxLabel: "X:"
            spinBoxUnit: "°"
            singleStep: 45
            acceptDot: true
            instantAccept: false
            precision: 2
            spinBoxTextColor: Colors.menuXAsis

            property string objectHelpText: "Rotate the model in X axis by 45 degrees (using the buttons) or any value when you enter the desired value in the text field"
            property url objectHelpImageSource: "../../images/help/RotateX.png"
        }
        LabeledSpinBox {
            id: xzSpinBox
            spinBoxLabel: "Y:"
            spinBoxUnit: "°"
            singleStep: 45
            acceptDot: true
            instantAccept: false
            precision: 2
            spinBoxTextColor: Colors.menuYAsis

            property string objectHelpText: "Rotate the model in Y axis by 45 degrees (using the buttons) or any value when you enter the desired value in the text field"
            property url objectHelpImageSource: "../../images/help/RotateY.png"
        }
        LabeledSpinBox {
            id: xySpinBox
            spinBoxLabel: "Z:"
            spinBoxUnit: "°"
            singleStep: 45
            acceptDot: true
            instantAccept: false
            precision: 2
            spinBoxTextColor: Colors.menuZAsis

            property string objectHelpText: "Rotate the model in Z axis by 45 degrees (using the buttons) or any value when you enter the desired value in the text field"
            property url objectHelpImageSource: "../../images/help/RotateZ.png"
        }
        Spacer {}
        MenuButton {
            id: placeButton
            menuButtonText: "Reset"

            helpText: "Restore the initial rotation values used when loading .stl file"
        }
    }
}
