import UM 1.3 as UM
import Cura 1.0 as Cura

ProfileDetailText {
    property string settingKey: ""
    property int extruder: 0
    property bool machineSetting: false

    value: {
        var value = propertyProvider.properties.value
        var unit = propertyProvider.properties.unit
        if(typeof(value) === 'string'){
            value = value.charAt(0).toUpperCase() + value.slice(1);
        }
        return value + unit
    }

    UM.SettingPropertyProvider
    {
        id: propertyProvider
        containerStackId: (machineExtruderCount.properties.value > 1 && !machineSetting) ? ExtruderManager.extruderStackId(extruder) : Cura.MachineManager.activeMachineId
        key: settingKey
        watchedProperties: [ "value", "unit" ]
        storeIndex: 0
        // Due to the way setPropertyValue works, removeUnusedValue gives the correct output in case of resolve
    }
}