import QtQuick 2.4
import QtQuick.Layouts 1.1

import "../singletons"
import "../layout/content"
import "../tweaks"
import UM 1.1 as UM
import Gence 1.0 as Gence

Item {

    property alias rect:                     rect
    property alias fill:                     fill
    property int   statusBarPercentageFill : 100
    property real  progress:                 UM.Backend.progress
    property real  progressLoading:          0.0

    Connections
    {
        target: UM.MeshFileHandler
        onReadingStopped:
        {
            progressLoading = 1 / Gence.Actions.numberOfSelectedFiles
            Gence.Actions.numberOfSelectedFiles -= 1
        }
    }

    Layout.fillWidth:  true
    Layout.fillHeight: true
    x:                 0
    anchors.bottom:    parent.bottom

    Rectangle {
        id:     rect
        width:  parent.width
        height: parent.height - Globals.decoratorHeight
        color:  Colors.statusBarMain
    }

    Connections
    {
        target: rect
        onWidthChanged:
        {
            fill.width = parent.width * progress
        }
    }

    Rectangle {
        id:     bottom
        width:  parent.width
        height: Globals.decoratorHeight
        color:  Colors.statusBarBottom
        y:      rect.y + rect.height
    }

    Rectangle {
        id:     fill
        width:  parent.width * progress
        //Behavior on width { PropertyAnimation {} }
        height: rect.height
        color:  Colors.statusBarFill
    }


    Component {
        id: status_after_content_comp
        StatusAfterContent {}
    }

    Loader {
        id:              status_ac_loader
        anchors.fill:    parent
        asynchronous:    true
        sourceComponent: status_after_content_comp
    }

    ButtonTweaks {
        helpText: "Here the model details (name, quantity, volume) and software status are displayed"
        hoverIndicatorEnabled: false
    }
}

