// Copyright (c) 2015 Ultimaker B.V.
// Uranium is released under the terms of the AGPLv3 or higher.

import QtQuick 2.2
import QtQuick.Controls 1.1

import "../../singletons"

Rectangle {
    id: tabBorder

    property alias text: text.text
    property alias mouseArea: mouseArea
    property int setWidth: 10
    property int setHeight: 20

    property bool checked: false

    width: setWidth - 1
    height: setHeight - 1

    border.width: 1
    border.color: checked ? Colors.buttonDecorator : Colors.customSettingsEditBorder

    color: "transparent"

    Text {
        id: text
        anchors.fill: parent
        anchors.margins: font.pixelSize / 3

        text: "tab"
        font.pixelSize: Globals.fontPixelSize
        font.family: Fonts.boxed

        color: Colors.customSettingsLabel

        verticalAlignment: Text.AlignVCenter
        horizontalAlignment: Text.AlignHCenter
        elide: Text.ElideLeft
    }

    MouseArea {
        id: mouseArea
        anchors.fill: parent

        onClicked: forceActiveFocus()
    }

    function setChecked(tabName) {
        if(tabName === text.text) {
            checked = true
        } else if (checked === true) {
            checked = false
        }
        
    }
}
