pragma Singleton

import QtQuick 2.0

Item {
    //background colors
    readonly property color menuBackground: "#CCCCCE"
    readonly property color backgroundColor: "#00F6F6F6"

    //base button colors
    readonly property color buttonTextBackground: "#333335"
    readonly property color buttonText: "#FFFFFF"
    readonly property color buttonDecorator: "#DF2530"
    readonly property color buttonBackground: "#FFFFFF"
    readonly property color clickedButtonBackground: "#717173"
    readonly property color buttonArrowColor: "#DF292F"
    readonly property color buttonDeactivator: "#ACFFFFFF"
    readonly property color buttonClicked: "#FFFFFF"
    readonly property color buttonHovered: "#FFFFFF"

    //right menu button colors
    readonly property color buttonOptionText: "#323235"
    readonly property color buttonOptionTextClicked: "#FFFFFF"
    readonly property color profileDetailsText: "#767679"

    //action button colors
    readonly property color actionButtonBackground: "#D70C1F"
    readonly property color actionButtonDecorator: "#A70918"

    //spinBox colors
    readonly property color spinBoxButton: "#DE292F"
    readonly property color spinBoxButtonText: "#FFFFFF"
    readonly property color spinBoxEditText: "#717173"
    readonly property color spinBoxEditTextNotValid: "#DF2530"
    readonly property color spinBoxEdit: "#FFFFFF"
    readonly property color spinBoxLabelText: "#717173"

    //button menu colors
    readonly property color buttonMenuBackground: "#F1F1F3"
    readonly property color buttonMenuBorder: "#333335"

    //logo background color
    readonly property color logoBackground: "#333335"

    //pseudo-shadow colors
    readonly property color shadowDarker: "#80000002"
    readonly property color shadowLighter: "#20000002"

    //button in button menu colors
    readonly property color menuButton: "#717173"

    //status bar colors
    readonly property color statusBarTop: "#7B7B7D"
    readonly property color statusBarMain: "#818183"
    readonly property color statusBarBottom: "#555555"
    readonly property color statusBarFill: "#717173"
    readonly property color statusBarText: "#FFFFFF"

    //retractable list colors
    readonly property color listBackground: "#FFFFFF"
    readonly property color listText: "#717173"
    readonly property color listHighlightedBackground: "#717173"
    readonly property color listHighlightedText: "#FFFFFF"
    readonly property color listBorder: "#DFDFDF"

    //cube colors
    readonly property color cubeActiveSide: "#DE2930"
    readonly property color cubeInactiveSide: "#FFFFFF"
    readonly property color cubeActiveDot: "#DE2930"
    readonly property color cubeInactiveDot: "#000000"
    readonly property color cubeDescription: "#717173"

    //slider colors
    readonly property color sliderHandle: "#DE292E"
    readonly property color sliderGroove: "#717173"
    readonly property color sliderLLColor: "#951C21"
    readonly property color sliderLayerTextBackground: "#FFFFFF"
    readonly property color sliderLayerText: "#717173"

    //rotate menu
    readonly property color menuXAsis: "#640000"
    readonly property color menuYAsis: "#006400"
    readonly property color menuZAsis: "#000064"

    //context help
    readonly property color contextHelpBorder: "#333335"
    readonly property color contextHelpBackground: "#FFFFFF"
    readonly property color contextHelpText: "#323235"

    //custom listView
    readonly property color customListBackground: "#FFFFFF"
    readonly property color customListBorder: "#E3E3E4"
    readonly property color customListText: "#717173"
    readonly property color customListScrollBarHandle: "#333335"
    readonly property color customListSelectedBackground: customListText
    readonly property color customListSelectedText: customListBackground

    //custom settings
    readonly property color customSettingsLabel: buttonOptionText
    readonly property color customSettingsText: customListText
    readonly property color customSettingsUnit: "#A1A1A3"
    readonly property color customSettingsEditBorder: customListBorder
    readonly property color disabledBackground: buttonMenuBackground
    readonly property color enabledBackground: "#FFFFFF"
    readonly property color warningBackground: "#FFCBA4"
    readonly property color errorBackground: "#FFA4A9"
    readonly property color revertButton: customSettingsText
}