pragma Singleton
import QtQuick 2.0

Item {
    signal customSignal()

    property bool multiextruderPrint: false

    property int buttonHeight
    property int decoratorHeight: buttonHeight * 0.05
    property int buttonHeaderHeight: buttonHeight * 0.33
    property int buttonTriangleSize: buttonHeight * 0.1
    property int leftMenuButtonIconSize: buttonHeight * 0.35
    property int rightMenuButtonIconSize: buttonHeight * 0.57

    property int menuBorderWidth: buttonHeight * 0.04
    property int menuMargin: buttonHeight * 0.2

    property int emptyMenuHeight: menuMargin * 2 + buttonHeaderHeight + decoratorHeight + menuBorderWidth

    //fonts
    property int fontPixelSize: buttonHeight * 0.17
    property int statusFontPixelSize: fontPixelSize * 1.3
    property int statusBigFontPixelSize: fontPixelSize * 1.4
    property int statusHeaderFontPixelSize: fontPixelSize * 1.6
    property int helpFontPixelSize: statusFontPixelSize
    property int actionButtonFontPixelSize: buttonHeight * 0.2

    property int doubleSpinBoxHeight: fontPixelSize * 4

    //baseWindowSize
    property int baseWidth

    //modalWindow
    property var modalWindow

    //customSettingsWindow
    property int spacing: Math.max(1, buttonHeight * 0.02)
    property int margin: buttonHeight * 0.1
    property int controlHeight: buttonHeight * 0.33

    property int scrollBarWidth: buttonHeight * 0.05 < 3 ? 3 : buttonHeight * 0.05
}
