pragma Singleton
import QtQuick 2.0

Item {
    readonly property string printerButton: "Select the printer that you want to print the model on."
    readonly property string splitButton:   "Split model to several parts.\n\n" +
                                            "Cut types:\n" +
                                            "Simple - Cut model with plane in X, Y or Z axis.\n" +
                                            "Divide - Split model that contain several geometries (closed " +
                                            "meshes) into single models.\n" +
                                            "Advanced - Cut model with plane in X, Y or Z axis with " +
                                            "automatically generated joints."
    readonly property string simpleSplit:   "Cut model with plane in X, Y or Z axis. Set parameters (axis and " +
                                            "placement of the plane) and confirm using „Split Model” button."
    readonly property url simpleSplitImg:   "../images/help/SimpleSplit.png"
    readonly property string advancedSplit: "Cut model with plane with automatically generated joints. Object " +
                                            "will be splitted only when at least one joint will be available to " +
                                            "generate.\n\n" +
                                            "Edge (A) - Offset from the edge of the model.\n" +
                                            "Angle (B) - Joint angle.\n" +
                                            "Offset (C) - Offset between splitted parts.\n" +
                                            "Depth (D) - Maximal joint depth.\n" +
                                            "Invert - Change joint direction.\n"
    readonly property url advancedSplitImg:   "../images/help/AdvancedSplit.png"
    readonly property string divideSplit:   "Split model that contain several geometries (closed meshes) into " +
                                            "single models and confirm using „Split Model” button."
    readonly property string multimaterialSwitch: "Choose the tool to print the selected model with.\n\n" +
                                            "[0] - Tool 0, typically model material\n" +
                                            "[1] - Tool 1, typically support material\n" +
                                            "[-] - Default options"
}