import QtQuick 2.4
import QtQuick.Layouts 1.1
import UM 1.0 as UM
import "../singletons"

import Gence 1.0 as Gence

Item {
    property alias sliderWithButtons: sliderWithButtons

    anchors.fill:      parent
    Layout.fillHeight: true
    Layout.fillWidth:  true


    Connections
    {
        target:      Gence.Actions.layerWasChanged
        onTriggered: sliderWithButtons.value = UM.LayerView.currentLayer
    }

    ColumnLayout {

        SliderWithButtons {

            id: sliderWithButtons

            onVisibleChanged:
            {

                value = UM.LayerView.numLayers - 1

                if(parent.visible)
                {
                    setMax (UM.LayerView.numLayers)
                    setMin (0)
                }

            }

            value: UM.LayerView.numLayers;

            onValueChanged: function () {
                UM.LayerView.setCurrentLayer (value)
            }
        }
    }
}
