import QtQuick 2.4
import QtQuick.Layouts 1.1

import "../singletons"
import "../tweaks"

Item {
    property alias instantAccept: spinBoxA.instant
    property alias acceptDot: spinBoxA.acceptDot
    property alias precision: spinBoxA.precision
    
    property alias spinBoxLabel: spinBoxLabel.text
    property alias spinBoxAUnit: spinBoxA.unitString
    property alias spinBoxBUnit: spinBoxB.unitString

    property alias topTextField: spinBoxA.textField
    property alias bottomTextField: spinBoxB.textField

    property alias topPlusAction: spinBoxA.plusButtonAction
    property alias topMinusAction: spinBoxA.minusButtonAction

    property alias bottomPlusAction: spinBoxB.plusButtonAction
    property alias bottomMinusAction: spinBoxB.minusButtonAction

    property alias onTopValueChanged: spinBoxA.onValueChanged
    property alias onBottomValueChanged: spinBoxB.onValueChanged

    property alias topValue: spinBoxA.value
    property alias bottomValue: spinBoxB.value

    property alias topSpinBox : spinBoxA
    property alias bottomSpinBox: spinBoxB


    Layout.fillWidth: true
    Layout.preferredHeight: Globals.doubleSpinBoxHeight
    Layout.alignment: Qt.AlignCenter

    property string objectHelpText: ""
    property string objectHelpImageSource: ""

    RowLayout {
        anchors.fill: parent
        spacing: 5

        SpinBoxLabel {
            id: spinBoxLabel
        }

        ColumnLayout {
            anchors.verticalCenter: parent.verticalCenter
            CustomSpinBox {
                id: spinBoxA
                Layout.fillWidth: true
            }

            CustomSpinBox {
                id: spinBoxB
                instant: spinBoxA.instant
                acceptDot: spinBoxA.acceptDot
                precision: spinBoxA.precision
                Layout.fillWidth: true
            }
        }
    }

    ButtonTweaks{
        id: spinBoxHelpTweak
        z: -1
        helpText: objectHelpText
        helpImageSource: objectHelpImageSource
        hoverIndicatorEnabled: false
    }
}
