# Copyright (c) 2015 Ultimaker B.V.
# Uranium is released under the terms of the AGPLv3 or higher.

from UM.Scene.SceneNode import SceneNode


from UM.Operations.TranslateOperation import TranslateOperation
from UM.Operations.Operation import Operation


class GenceTranslateOperation(TranslateOperation):

    def __init__(self, node, translation, set_position = False,mergeKey=None):
        super().__init__(node,translation,set_position)

        self._mergeKey = mergeKey


    def mergeWith(self, other):
        if type(other) is not GenceTranslateOperation:
            return False
        if other._node != self._node: # Must be moving the same node.
            return False
        if other._mergeKey != self._mergeKey:
            return False

        op = GenceTranslateOperation(self._node, self._translation + other._translation,self._set_position,self._mergeKey)
        op._old_transformation = other._old_transformation # Use the oldest transformation of the two to restore if we undo.
        return op

